"use strict";

var UP_CASE_REG = /\B([A-Z])/g;

var triggleVisible = function (instance, visible) {
  instance.setData({
    visibility: visible
  }, function () {
    if (visible) {
      instance.triggerEvent('onShow');
      instance.triggerEvent('Show');
    } else {
      instance.triggerEvent('onHide');
      instance.triggerEvent('Hide');
    }
  });
};

var loadStyle = function (instance, maskStyle, contentStyle) {
  var maskStyleState = computeStyle(maskStyle);
  var contentStyleState = computeStyle(contentStyle);
  instance.setData({
    maskStyleState: maskStyleState,
    contentStyleState: contentStyleState
  });
};

console.warn('组件所依赖的 rax-modal 版本较旧，请重新构建发布该组件');
Component({
  data: {
    visibility: false,
    maskStyleState: '',
    contentStyleState: ''
  },
  properties: {
    visible: {
      type: Boolean,
      value: false
    },
    maskStyle: {
      type: Object,
      value: {}
    },
    contentStyle: {
      type: Object,
      value: {}
    },
    maskCanBeClick: {
      type: Boolean,
      value: true
    },
    delay: {
      type: Number,
      value: 0
    },
    duration: {
      type: Number,
      value: 300
    }
  },
  options: {
    styleIsolation: 'apply-shared'
  },
  attached: function attached() {
    var _this = this;

    var _this$properties = this.properties,
        delay = _this$properties.delay,
        visible = _this$properties.visible,
        maskStyle = _this$properties.maskStyle,
        contentStyle = _this$properties.contentStyle;

    if (visible) {
      if (delay) {
        setTimeout(function () {
          triggleVisible(_this, visible, true);
        }, delay);
      } else {
        triggleVisible(this, visible, true);
      }

      loadStyle(this, maskStyle, contentStyle);
    }
  },
  observers: {
    visible: function visible(_visible) {
      var _this2 = this;

      if (this.data.visibility !== _visible) {
        if (this.properties.delay) {
          setTimeout(function () {
            triggleVisible(_this2, _visible);
          }, this.properties.delay);
        } else {
          triggleVisible(this, _visible);
        }
      }
    },
    'maskStyle, contentStyle': function maskStyleContentStyle(maskStyle, contentStyle) {
      loadStyle(this, maskStyle, contentStyle);
    }
  },
  methods: {
    onClick: function onClick() {
      var maskCanBeClick = this.properties.maskCanBeClick;

      if (maskCanBeClick) {
        this.triggerEvent('onHide');
        this.triggerEvent('Hide');
      } // In wechat miniprogram couldn't check function props wheather exist


      this.triggerEvent('onMaskClick');
      this.triggerEvent('MaskClick');
    }
  }
});

function computeStyle(style) {
  var handledStyle = '';
  Object.keys(style).forEach(function (key) {
    handledStyle = handledStyle + (key.replace(UP_CASE_REG, '-$1').toLowerCase() + ": " + style[key] + ";");
  });
  return handledStyle;
}